﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using GridCascadingCombo_test.Models;
using Infragistics.Web.Mvc;

namespace GridCascadingCombo_test.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        [GridDataSourceAction]
        public ActionResult GetCompartmentData()
        {
            List<CompartmentModel> compartments = new List<CompartmentModel>();

            compartments.Add(new CompartmentModel
            {
                CompartmentId = 1,
                CRef = 1,
                SCRef = "a",
                PSId = 1,
                Species = "AA",
                YCId = 1,
                YMId = 1
            });

            compartments.Add(new CompartmentModel
            {
                CompartmentId = 2,
                CRef = 1,
                SCRef = "b",
                PSId = 1,
                Species = "AA",
                YCId = 4,
                YMId = 2
            });

            compartments.Add(new CompartmentModel
            {
                CompartmentId = 3,
                CRef = 1,
                SCRef = "c",
                PSId = 16,
                Species = "BB",
                YCId = 10,
                YMId = 6
            });

            compartments.Add(new CompartmentModel
            {
                CompartmentId = 4,
                CRef = 2,
                SCRef = "a",
                PSId = 24,
                Species = "CE",
                YCId = 15,
                YMId = 8
            });

            return View(compartments.AsQueryable());
        }

        public ActionResult CompartmentSaveData()
        {
            GridModel gridModel = new GridModel();
            List<Transaction<CompartmentModel>> transactions =
                gridModel.LoadTransactions<CompartmentModel>(HttpContext.Request.Form["ig_transactions"]);

            // For more refer to: 
            // * http://www.igniteui.com/help/iggrid-updating
            // * http://www.igniteui.com/grid/basic-editing
            // * http://help.infragistics.com/jQuery/2015.1/ui.igGridUpdating
            //throw new NotImplementedException();

            return null;
        }
        [ComboDataSourceAction]
        public ActionResult GetSpeciesData()
        {
            List<SpeciesModel> speciesList = new List<SpeciesModel>();

            speciesList.Add(new SpeciesModel(){
                SpeciesCode = "AA",
                Description = "AA Species",
                PSSpecies = "AA",
                YMSpecies = "AA"
            }
            );

            speciesList.Add(new SpeciesModel()
            {
                SpeciesCode = "BB",
                Description = "BB Species",
                PSSpecies = "CE",
                YMSpecies = "DF"
            }
            );
            speciesList.Add(new SpeciesModel()
            {
                SpeciesCode = "CE",
                Description = "CE Species",
                PSSpecies = "CE",
                YMSpecies = "CE"
            }
           );
            speciesList.Add(new SpeciesModel()
            {
                SpeciesCode = "DF",
                Description = "DF Species",
                PSSpecies = "DF",
                YMSpecies = "DF"
            }
          );
            speciesList.Add(new SpeciesModel()
            {
                SpeciesCode = "FF",
                Description = "FF Species",
                PSSpecies = "AA",
                YMSpecies = "AA"
            }
            );

            return View(speciesList.AsQueryable());
        }

        [ComboDataSourceAction]
        public ActionResult GetYMData()
        {
            List<YMModel> ycHeaders = new List<YMModel>();

            ycHeaders.Add(new YMModel()
            {
                YMId = 1,
                YmNo = "102",
                Spacing = 12.9,
                Species = "AA"
            });
            ycHeaders.Add(new YMModel()
            {
                YMId = 2,
                YmNo = "103",
                Spacing = 10.1,
                Species = "AA"
            });
            ycHeaders.Add(new YMModel()
            {
                YMId = 4,
                YmNo = "104",
                Spacing = 1.6,
                Species = "AA"
            });
            ycHeaders.Add(new YMModel()
            {
                YMId = 6,
                YmNo = "86",
                Spacing = 10.1,
                Species = "DF"
            });
            ycHeaders.Add(new YMModel()
            {
                YMId = 7,
                YmNo = "87",
                Spacing = 13.21,
                Species = "DF"
            });
            ycHeaders.Add(new YMModel()
            {
                YMId = 8,
                YmNo = "135",
                Spacing = 10.1,
                Species = "CE"
            });
            return View(ycHeaders.AsQueryable());
        }

        [ComboDataSourceAction]
        public ActionResult GetYCData()
        {
            List<YCModel> ycClass = new List<YCModel>();
            ycClass.Add(new YCModel()
            {
                YCId = 1,
                YMId = 1,
                Description = "YC 1"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 2,
                YMId = 1,
                Description = "YC 2"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 3,
                YMId = 2,
                Description = "YC 3"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 4,
                YMId = 2,
                Description = "YC 4"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 5,
                YMId = 2,
                Description = "YC 5"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 10,
                YMId = 6,
                Description = "YC 10"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 15,
                YMId = 8,
                Description = "YC 15"
            });
            ycClass.Add(new YCModel()
            {
                YCId = 16,
                YMId = 8,
                Description = "YC 16"
            });

            return View(ycClass.AsQueryable());
        }

        [ComboDataSourceAction]
        public ActionResult GetPSData()
        {
            List<PSModel> ps = new List<PSModel>();
            ps.Add(new PSModel()
            {
                PSId = 1,
                Description = "PS1",
               Species = "AA"
            });
            ps.Add(new PSModel()
            {
                PSId = 2,
                Description = "PS2",
                Species = "AA"
            });
            ps.Add(new PSModel()
            {
                PSId = 16,
                Description = "PS5",
                Species = "DF"
            });
            ps.Add(new PSModel()
            {
                PSId = 24,
                Description = "PS24",
                Species = "CE"
            });
            ps.Add(new PSModel()
            {
                PSId = 25,
                Description = "PS25",
                Species = "CE"
            });
            ps.Add(new PSModel()
            {
                PSId = 26,
                Description = "PS26",
                Species = "CE"
            });






            return View(ps.AsQueryable());
        }
    }
}